import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.Socket;
import java.util.Vector;

class Koordinate {
    public int x, y;

    public Koordinate(int _x, int _y) {
        x = _x;
        y = _y;
    }
}

class ZeljenKorak {
    public int dx, dy;
}

class Comms {
    BufferedReader reader;
    PrintWriter writer;
}

public class LNZClient {
    public static void event_loop(Comms comms) throws Exception {

        Lovec t;
        String cmd;
        String cmda[];

        while (true) {
            cmd = comms.reader.readLine();
            cmda = cmd.split(" ");

            if (cmda[0].equals("ADIJO")) return;
            if (cmda[0].startsWith("KONEC_IGRE")) continue;
            if (!cmda[0].equals("ZBUDI_SE")) throw new Exception("Napaka pri komunikaciji s streznikom.");

            int[] cmdi = new int[cmda.length - 1];
            for (int i=0;i<cmdi.length;i++) {
                cmdi[i] = Integer.parseInt(cmda[i+1]);
            }

            int N = cmdi[0];
            int K = cmdi[1];

            Koordinate j0 = new Koordinate(cmdi[2], cmdi[3]);
            Koordinate n0 = new Koordinate(cmdi[4], cmdi[5]);

            Koordinate[] zakladi = new Koordinate[K];
            for (int i=0;i<K;i++) {
                zakladi[i] = new Koordinate(cmdi[6+2*i], cmdi[6+2*i+1]);
            }

            t = new Lovec();
            t.ZbudiSe(N, K, j0, n0, zakladi);

            comms.writer.format("BUDEN\n");
            comms.writer.flush();

            while (true) {
                cmd = comms.reader.readLine();
                cmda = cmd.split(" ");

                if (cmda[0].equals("ADIJO")) return;
                if (cmda[0].equals("KONEC_IGRE")) {
                    t.KonecIgre();
                    t = null;
                    break;
                } else if (cmda[0].equals("QV")) {
                    Koordinate j = new Koordinate(Integer.parseInt(cmda[1]), Integer.parseInt(cmda[2]));
                    Koordinate n = new Koordinate(Integer.parseInt(cmda[3]), Integer.parseInt(cmda[4]));

                    zakladi = pojej(zakladi, j);
                    zakladi = pojej(zakladi, n);

                    ZeljenKorak qv = new ZeljenKorak();
                    t.KamGres(j, n, zakladi, qv);

                    comms.writer.format("QVR %d %d\n", qv.dx, qv.dy);
                    comms.writer.flush();
                } else {
                }
            }
        }
    }

    public static Koordinate[] pojej(Koordinate[] zakladi, Koordinate k) {
        Vector<Koordinate> rz = new Vector<Koordinate>(zakladi.length);
        for (Koordinate zaklad: zakladi) {
            if (!((zaklad.x == k.x) && (zaklad.y == k.y))) {
                rz.add(zaklad);
            }
        }
        Koordinate[] rzjs = new Koordinate[rz.size()];
        rz.copyInto(rzjs);
        return rzjs;
    }

    public static void connect(String Hostname, Comms comms) throws Exception {
        Socket client = new Socket(Hostname, 1175);

        comms.reader = new BufferedReader(new InputStreamReader(client.getInputStream()));
        comms.writer = new PrintWriter(new OutputStreamWriter(client.getOutputStream()));

        String server = comms.reader.readLine();
        System.out.println(server);

        comms.writer.println("AVE " + Lovec.Ime);
        comms.writer.flush();

        String succ = comms.reader.readLine();
        if (!succ.equals("PRIJAVA USPESNA")) throw new Exception("Prijava na streznik neuspesna" + succ);
    }

    public static void main(String argv[]) throws Exception {
        String Hostname;
        if (argv.length < 2) Hostname = "localhost";
        else Hostname = argv[1];

        Comms comms = new Comms();
        connect(Hostname, comms);
        event_loop(comms);

    }
}
